int timeout = 0;

GUIImage@ icon;
GUIImage@ head_icon;
void Created(SceneObject@+ self)
{
	Engine.load_level("startlevel.xml");

	@Engine.Player = Engine.create_sceneobject("player", ESOT_ANIMATED);
	Engine.Player.Position = vector3df(64.0f, 64.0f, 64.0f + 2000);
	Engine.Player.Physics.add_collision_circle(1.0f, vector2df(0.0f, -1.0f));
	Engine.Player.Physics.Type = EBT_DYNAMIC;
	Engine.Player.Physics.FixedRotation = true;

	Engine.log("Created.");

	@Camera.Follow = Engine.Player;
	Camera.UseViewLimit = true;
	Camera.ViewLimit = rectf(0,0,2048,1024);

	AnimatedSceneObject@ anim = cast<AnimatedSceneObject>(Engine.Player);
	anim.Animation = "idle.gani";
	anim.Direction = 2;

	Physics.PixelsPerUnit = 16;

	@icon = GUI.create_image("hlm_avatar_trans.png", vector2di(20, 20));
	@head_icon = GUI.create_image("gui_image_test.png", vector2di(20+45+5, 20));
	head_icon.set_source_rect(recti(0,0,32,32));
}

void Update(SceneObject@+ self, uint tick)
{
	// Allow for a no movement timeout.
	if (timeout > 0)
	{
		timeout -= tick;
		if (timeout <= 0) head_icon.set_source_rect(recti(0,0,32,32));
		return;
	}

	// Determine if we can move.
	bool domove = false;
	u8 dir = 0;
	//float distance = 8.0f * ( float(tick) / 50.0f );
	vector2df move(0.0f, 0.0f);
	if (Engine.keydown(KEY_UP))
		{ move.Y -= 1.0f; dir = 0; domove = true; }
	if (Engine.keydown(KEY_LEFT))
		{ move.X -= 1.0f; dir = 1; domove = true; }
	if (Engine.keydown(KEY_DOWN))
		{ move.Y += 1.0f; dir = 2; domove = true; }
	if (Engine.keydown(KEY_RIGHT))
		{ move.X += 1.0f; dir = 3; domove = true; }

	// Update our position.
	if (domove)
	{
		// Normalize our move vector and multiply it by the distance we are going to move.
		//move.normalize();
		move *= 10.0f;
		//move *= distance;

		// Calculate our new position and update it.
		//self.Position = vector3df(self.Position.X + move.X, self.Position.Y + move.Y, (self.Position.Y + move.Y) + 2000);
		self.Physics.Velocity = move;
	}
	else self.Physics.Velocity = vector2df(0.0f, 0.0f);

	// If we are animated, show the walk animation.
	if (self.get_type() == ESOT_ANIMATED)
	{
		AnimatedSceneObject@ anim = cast<AnimatedSceneObject>(self);
		if (domove)
		{
			anim.Animation = "walk.gani";
			anim.Direction = dir;
		} else anim.Animation = "idle.gani";
	}
}

void OnKeyPress(SceneObject@+ self, EKEY_CODE key)
{
	if (key != KEY_SPACE && key != KEY_KEY_S) return;

	AnimatedSceneObject@ anim = cast<AnimatedSceneObject>(self);
	anim.Animation = "sword.gani";
	anim.Physics.Velocity = vector2df(0.0f, 0.0f);
	head_icon.set_source_rect(recti(32,0,64,32));

	vector2df pos(anim.Position.X, anim.Position.Y);
	if (anim.Direction == 0) pos.Y -= (2.0f * 16.0f);
	if (anim.Direction == 2) pos.Y += (2.0f * 16.0f);
	if (anim.Direction == 1) pos.X -= (3.5f * 16.0f);
	if (anim.Direction == 3) pos.X += (3.5f * 16.0f);
	
	Engine.send_event(self, "sword", "", pos, 32.0f);
	timeout = 300;
}
